﻿using System;
using System.Collections.Generic;
using Windows.ApplicationModel.Background;
using Windows.Foundation;
using Windows.Storage;

namespace TestProject
{
    /// <summary>
    /// 백그라운드 태스크 헬퍼
    /// </summary>
    public static class BackgroundTaskHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 백그라운드 태스크 진입점 1
        /// </summary>
        public const string BackgroundTaskEntryPoint1 = "TestLibrary.SampleBackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크명 1
        /// </summary>
        public const string BackgroundTaskName1 = "BackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크 진행 1
        /// </summary>
        public static string BackgroundTaskProgress1 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 1
        /// </summary>
        public static bool BackgroundTaskRegistered1 = false;


        /// <summary>
        /// 백그라운드 태스크 진입점 2
        /// </summary>
        public const string BackgroundTaskEntryPoint2 = "TestLibrary.SampleBackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크명 2
        /// </summary>
        public const string BackgroundTaskName2 = "BackgroundTask2";

        /// <summary>
        /// 백그라운드 태스크 진행 2
        /// </summary>
        public static string BackgroundTaskProgress2 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 2
        /// </summary>
        public static bool BackgroundTaskRegistered2 = false;


        /// <summary>
        /// 백그라운드 태스크 진입점 3
        /// </summary>
        public const string BackgroundTaskEntryPoint3 = "TestLibrary.SampleBackgroundTask2";

        /// <summary>
        /// 백그라운드 태스크명 3
        /// </summary>
        public const string BackgroundTaskName3 = "BackgroundTask3";

        /// <summary>
        /// 백그라운드 태스크 진행 3
        /// </summary>
        public static string BackgroundTaskProgress3 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 3
        /// </summary>
        public static bool BackgroundTaskRegistered3 = false;



        /// <summary>
        /// 백그라운드 태스크 진입점 4
        /// </summary>
        public const string BackgroundTaskEntryPoint4 = "TestLibrary.SampleBackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크명 4
        /// </summary>
        public const string BackgroundTaskName4 = "BackgroundTask4";

        /// <summary>
        /// 백그라운드 태스크 진행 4
        /// </summary>
        public static string BackgroundTaskProgress4 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 4
        /// </summary>
        public static bool BackgroundTaskRegistered4 = false;


        /// <summary>
        /// 백그라운드 태스크 진입점 5
        /// </summary>
        public const string BackgroundTaskEntryPoint5 = "TestLibrary.SampleBackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크명 5
        /// </summary>
        public const string BackgroundTaskName5 = "BackgroundTask5";

        /// <summary>
        /// 백그라운드 태스크 진행 5
        /// </summary>
        public static string BackgroundTaskProgress5 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 5
        /// </summary>
        public static bool BackgroundTaskRegistered5 = false;

        /// <summary>
        /// 백그라운드 태스크 결과 5
        /// </summary>
        public static string BackgroundTaskResult5 = string.Empty;


        /// <summary>
        /// 백그라운드 태스크 진입점 6
        /// </summary>
        public const string BackgroundTaskEntryPoint6 = "TestLibrary.SampleBackgroundTask1";

        /// <summary>
        /// 백그라운드 태스크명 6
        /// </summary>
        public const string BackgroundTaskName6 = "BackgroundTask6";

        /// <summary>
        /// 백그라운드 태스크 그룹 ID 6
        /// </summary>
        public const string BackgroundTaskGroupID6 = "3F2504E0-5F89-41D3-9A0C-0405E82C3333";

        /// <summary>
        /// 백그라운드 태스크 그룹명 6
        /// </summary>
        public const string BackgroundTaskGroupName6 = "BackgroundTaskGroup6";

        /// <summary>
        /// 백그라운드 태스크 진행 6
        /// </summary>
        public static string BackgroundTaskProgress6 = string.Empty;

        /// <summary>
        /// 백그라운드 태스크 등록 여부 6
        /// </summary>
        public static bool BackgroundTaskRegistered6 = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 백그라운드 태스크 상태 구하기 - GetBackgroundTaskStatus(name)

        /// <summary>
        /// 백그라운드 태스크 상태 구하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <returns>백그라운드 태스크 상태</returns>
        public static string GetBackgroundTaskStatus(string name)
        {
            bool registered = false;

            switch(name)
            {
                case BackgroundTaskName1 : registered = BackgroundTaskRegistered1; break;
                case BackgroundTaskName2 : registered = BackgroundTaskRegistered2; break;
                case BackgroundTaskName3 : registered = BackgroundTaskRegistered3; break;
                case BackgroundTaskName4 : registered = BackgroundTaskRegistered4; break;
                case BackgroundTaskName5 : registered = BackgroundTaskRegistered5; break;
                case BackgroundTaskName6 : registered = BackgroundTaskRegistered6; break;
            }

            string status = registered ? "등록" : "미등록";

            object taskStatus;

            ApplicationDataContainer container = ApplicationData.Current.LocalSettings;

            if(container.Values.TryGetValue(name, out taskStatus))
            {
                status += " - " + taskStatus.ToString();
            }

            return status;
        }

        #endregion
        #region 백그라운드 태스크 등록 상태 업데이트하기 - UpdateBackgroundTaskRegistrationStatus(name, registered)

        /// <summary>
        /// 백그라운드 태스크 등록 상태 업데이트하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <param name="registered">등록 여부</param>
        public static void UpdateBackgroundTaskRegistrationStatus(string name, bool registered)
        {
            switch(name)
            {
                case BackgroundTaskName1 : BackgroundTaskRegistered1 = registered; break;
                case BackgroundTaskName2 : BackgroundTaskRegistered2 = registered; break;
                case BackgroundTaskName3 : BackgroundTaskRegistered3 = registered; break;
                case BackgroundTaskName4 : BackgroundTaskRegistered4 = registered; break;
                case BackgroundTaskName5 : BackgroundTaskRegistered5 = registered; break;
                case BackgroundTaskName6 : BackgroundTaskRegistered6 = registered; break;
            }
        }

        #endregion
        #region 백그라운드 액세스 필요 여부 구하기 - RequiresBackgroundAccess(name)

        /// <summary>
        /// 백그라운드 액세스 필요 여부 구하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <returns>백그라운드 액세스 필요 여부</returns>
        public static bool RequiresBackgroundAccess(string name)
        {
            if((name == BackgroundTaskName4) || (name == BackgroundTaskName5))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        #endregion

        #region 백그라운드 태스크 등록하기 - RegisterBackgroundTask(taskEntryPoint, name, trigger, condition, taskGroup)

        /// <summary>
        /// 백그라운드 태스크 등록하기
        /// </summary>
        /// <param name="taskEntryPoint">태스크 진입점</param>
        /// <param name="name">명칭</param>
        /// <param name="trigger">백그라운드 트리거</param>
        /// <param name="condition">백그라운드 조건</param>
        /// <param name="taskGroup">백그라운드 태스크 등록 그룹</param>
        /// <returns>백그라운드 태스크 등록</returns>
        public static BackgroundTaskRegistration RegisterBackgroundTask
        (
            string                          taskEntryPoint,
            string                          name,
            IBackgroundTrigger              trigger,
            IBackgroundCondition            condition,
            BackgroundTaskRegistrationGroup taskGroup = null
        )
        {
            if(RequiresBackgroundAccess(name))
            {
                IAsyncOperation<BackgroundAccessStatus> asyncOperation = BackgroundExecutionManager.RequestAccessAsync();
            }

            BackgroundTaskBuilder builder = new BackgroundTaskBuilder();

            builder.Name           = name;
            builder.TaskEntryPoint = taskEntryPoint;

            builder.SetTrigger(trigger);

            if(condition != null)
            {
                builder.AddCondition(condition);

                builder.CancelOnConditionLoss = true; // 백그라운드 작업이 실행되는 동안 조건이 변경되면 취소된다.
            }

            if(taskGroup != null)
            {
                builder.TaskGroup = taskGroup;
            }

            BackgroundTaskRegistration backgroundTaskRegistration = builder.Register();

            UpdateBackgroundTaskRegistrationStatus(name, true);

            // 이전 완료 상태를 제거합니다.
            ApplicationDataContainer container = ApplicationData.Current.LocalSettings;

            container.Values.Remove(name);

            return backgroundTaskRegistration;
        }

        #endregion
        #region 백그라운드 태스크 등록취소하기 - UnregisterBackgroundTasks(name, taskGroup)

        /// <summary>
        /// 백그라운드 태스크 등록취소하기
        /// </summary>
        /// <param name="name">명칭</param>
        /// <param name="taskGroup">백그라운드 태스크 등록 그룹</param>
        public static void UnregisterBackgroundTasks(string name, BackgroundTaskRegistrationGroup taskGroup = null)
        {
            // 지정된 작업 그룹이 등록된 경우 해당 그룹과 관련된 모든 백그라운드 작업을 반복하고
            // 지정된 이름을 가진 모든 작업을 등록 취소합니다.
            if(taskGroup != null)
            {
                foreach(KeyValuePair<Guid, BackgroundTaskRegistration> keyValuePair in taskGroup.AllTasks)
                {
                    if(keyValuePair.Value.Name == name)
                    {
                        keyValuePair.Value.Unregister(true);
                    }
                }
            }
            else
            {
                // 그룹화되지 않은 모든 백그라운드 작업을 반복하고 지정된 이름으로 등록을 취소합니다.
                foreach(KeyValuePair<Guid, IBackgroundTaskRegistration> keyValuePair in BackgroundTaskRegistration.AllTasks)
                {
                    if(keyValuePair.Value.Name == name)
                    {
                        keyValuePair.Value.Unregister(true);
                    }
                }
            }

            UpdateBackgroundTaskRegistrationStatus(name, false);
        }

        #endregion

        #region 백그라운드 태스크 등록 그룹 구하기 - GetTaskGroup(id, groupName)

        /// <summary>
        /// 백그라운드 태스크 등록 그룹 구하기
        /// </summary>
        /// <param name="id">ID</param>
        /// <param name="groupName">그룹명</param>
        /// <returns>백그라운드 태스크 등록 그룹</returns>
        public static BackgroundTaskRegistrationGroup GetTaskGroup(string id, string groupName)
        {
            BackgroundTaskRegistrationGroup group = BackgroundTaskRegistration.GetTaskGroup(id);

            if(group == null)
            {
                group = new BackgroundTaskRegistrationGroup(id, groupName);
            }

            return group;
        }

        #endregion
    }
}